## postgis 2.2.1+dfsg

=== extensions/Makefile ===
#############################################################################
#
# Master Makefile used to build extensions
# Copyright (C) 2012 Regina Obe and Leo Hsu <lr@pcorp.us>
# Copyright (C) 2012 Sandro Santilli <strk@keybit.net>
#
# This is free software; you can redistribute and/or modify it under
# the terms of the GNU General Public Licence. See the COPYING file.
#
#############################################################################

SUBDIRS = postgis 
SUBDIRS += postgis_tiger_geocoder 
ifeq (topology,topology)
	SUBDIRS += postgis_topology
endif
ifeq (sfcgal,sfcgal)
	SUBDIRS += postgis_sfcgal
endif

ifeq (address_standardizer,address_standardizer)
	SUBDIRS += address_standardizer
endif

all clean distclean install uninstall installcheck:
	for DIR in $(SUBDIRS); do \
		echo "---- Making $@ in $${DIR}"; \
		$(MAKE) -C "$${DIR}" $@ || exit 1; \
	done

distclean: distclean-local

distclean-local:
	rm -f Makefile


check:
	@echo "Nothing to check"

=== raster/Makefile ===
#############################################################################
#
# Master Makefile used to build WKT Raster
#
# Copyright (c) 2009 Sandro Santilli <strk@keybit.net>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#############################################################################

all:     

corelib:
	$(MAKE) -C rt_core

pglib:
	$(MAKE) -C rt_pg

rtloader:
	$(MAKE) -C loader

rtpostgis.sql:
	$(MAKE) -C rt_pg rtpostgis.sql

install: all
	$(MAKE) -C rt_pg install
	$(MAKE) -C loader install
	$(MAKE) -C scripts install

uninstall:
	$(MAKE) -C rt_pg uninstall
	$(MAKE) -C loader uninstall
	$(MAKE) -C scripts uninstall

clean:
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@

distclean: clean
	$(MAKE) -C rt_core $@
	$(MAKE) -C rt_pg $@
	$(MAKE) -C loader $@
	$(MAKE) -C test $@
	$(MAKE) -C scripts $@
	rm -f raster_config.h Makefile

core-check:
	$(MAKE) -C test $@

check:
	$(MAKE) -C test $@

=== extensions/address_standardizer/Makefile ===
OBJS = \
    address_parser.o \
    address_standardizer.o \
    std_pg_hash.o \
    analyze.o \
    err_param.o \
    export.o \
    gamma.o \
    hash.o \
    lexicon.o \
    pagc_tools.o \
    parseaddress-api.o \
    standard.o \
    tokenize.o

OBJS_test_main = \
    test_main.o \
    analyze.o \
    err_param.o \
    export.o \
    gamma.o \
    hash.o \
    lexicon.o \
    pagc_tools.o \
    standard.o \
    tokenize.o

POSTGIS_PGSQL_VERSION=93
# SQL preprocessor
SQLPP = /usr/bin/cpp -traditional-cpp -w -P
GREP=/bin/grep
PERL=/usr/bin/perl
EXTVERSION    = 2.2.1
MINORVERSION  = 2.2
MODULE_big = address_standardizer-2.2
EXTENSION = address_standardizer
DATA = address_standardizer_data_us.control sql/$(EXTENSION).sql sql/$(EXTENSION)_data_us.sql

all:  sql/address_standardizer.sql sql/address_standardizer--1.0--$(EXTVERSION).sql sql/address_standardizer--$(EXTVERSION).sql sql/address_standardizer--$(EXTVERSION)--$(EXTVERSION)next.sql sql/address_standardizer--$(EXTVERSION)next--$(EXTVERSION).sql \
 sql/$(EXTENSION)_data_us.sql sql/address_standardizer--2.2.1.sql sql/$(EXTENSION)_data_us--2.2.1.sql  sql/$(EXTENSION)_data_us--$(EXTVERSION)--$(EXTVERSION)next.sql \
sql/$(EXTENSION)_data_us--$(EXTVERSION)next--$(EXTVERSION).sql \
sql/test-init-extensions.sql sql/test-parseaddress.sql sql/test-standardize_address_1.sql sql/test-standardize_address_2.sql

EXTRA_CLEAN += sql/*.sql



DOCS = README.address_standardizer
PG_CPPFLAGS =  -I/var/lib/jenkins/workspace/geos/rel-3.5.1devw64/include  -I/usr/include/libxml2 -I/usr/include -DHAVE_SFCGAL   -I/var/lib/jenkins/workspace/pg/rel/pg9.3w64/pg9.3/include -g -O0

SHLIB_LINK =  -L/var/lib/jenkins/workspace/geos/rel-3.5.1devw64/lib  -lgeos_c -lproj  -ljson-c -lxml2 -L/usr/lib/x86_64-linux-gnu -lSFCGAL  -Wl,--exclude-libs,ALL -lpcre
EXTRA_CLEAN = usps-st-city-name.txt mk-st-regexp mk-city-regex test_main
REGRESS = test-init-extensions test-parseaddress test-standardize_address_1 test-standardize_address_2

# PGXS information
PG_CONFIG = /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PGVER := $(shell $(PG_CONFIG) --version)


# Set PERL _after_ the include of PGXS
PERL=/usr/bin/perl

# Borrow the $libdir substitution from PGXS but customise by running the preprocessor
# and adding the version number
sql/%.sql: %.sql.in
	mkdir -p sql
	$(SQLPP) -I../libpgcommon $< | grep -v '^#' | \
	$(PERL) -lpe "s'MODULE_PATHNAME'\$$libdir/${EXTENSION}-${MINORVERSION}'g" > $@
	
sql/address_standardizer--2.2.1.sql: sql/address_standardizer_types.sql \
    sql/address_standardizer_functions.sql
	cat $^ > $@
	
sql/address_standardizer.sql: sql/address_standardizer_types.sql \
    sql/address_standardizer_functions.sql
	cat $^ > $@
	
sql/address_standardizer--1.0--$(EXTVERSION).sql:  sql/address_standardizer_functions.sql
	cat $^ > $@
	
# upgrade logic for us data extension (to go to next cludge for dev upgrading)
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: sql/address_standardizer_functions.sql
	cat $^ > $@

# upgrade logic for us data extension (to go to original round-robin yoyo cludge for dev upgrading)
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/address_standardizer_functions.sql
	cat $^ > $@		
	
# build us data extension
sql/$(EXTENSION)_data_us--$(EXTVERSION).sql: us_lex.sql us_gaz.sql us_rules.sql sql_bits/address_standardizer_data_us_mark_editable_objects.sql.in
	mkdir -p sql
	cat $^ > $@
	
sql/$(EXTENSION)_data_us.sql: us_lex.sql us_gaz.sql us_rules.sql sql_bits/address_standardizer_data_us_mark_editable_objects.sql.in
	mkdir -p sql
	cat $^ > $@
	
# upgrade logic for us data extension (to go to next cludge for dev upgrading)
sql/$(EXTENSION)_data_us--$(EXTVERSION)--$(EXTVERSION)next.sql: sql/$(EXTENSION)_data_us--$(EXTVERSION).sql
	cat $^ > $@

# upgrade logic for us data extension (to go to original round-robin yoyo cludge for dev upgrading)
sql/$(EXTENSION)_data_us--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)_data_us--$(EXTVERSION).sql
	cat $^ > $@	
	
mk-st-regexp: mk-st-regexp.pl
	$(PERL) -c mk-st-regexp.pl
	rm -f mk-st-regexp
	echo "#! " $(PERL) > mk-st-regexp
	cat mk-st-regexp.pl >> mk-st-regexp
	chmod ugo+x mk-st-regexp

mk-city-regex: mk-city-regex.pl usps-st-city-name.txt
	$(PERL) -c mk-city-regex.pl
	rm -f mk-city-regex
	echo "#! " $(PERL) > mk-city-regex
	cat mk-city-regex.pl >> mk-city-regex
	chmod ugo+x mk-city-regex

usps-st-city-name.txt: usps-st-city-orig.txt usps-st-city-adds.txt
	cat usps-st-city-orig.txt usps-st-city-adds.txt | sort -u >usps-st-city-name.txt

#parseaddress-stcities.h: mk-city-regex
#	./mk-city-regex > parseaddress-stcities.h

#parseaddress-regex.h: mk-st-regexp
#	./mk-st-regexp > parseaddress-regex.h

dist-clean:
	rm -f mk-st-regexp mk-city-regex usps-st-city-name.txt test_main Makefile


test_main: $(OBJS_test_main)
	gcc -o test_main $(OBJS_test_main) $(LDFLAGS) $(LIBS)

test_main.o: test_main.c pagc_api.h pagc_std_api.h

address_parser.o: address_parser.c parseaddress-api.h

address_standardizer.o: address_standardizer.c std_pg_hash.h pagc_api.h pagc_std_api.h

analyze.o: analyze.c pagc_api.h

err_param.o: err_param.c pagc_api.h

export.o: export.c pagc_api.h pagc_tools.h

gamma.o: gamma.c pagc_api.h pagc_std_api.h gamma.h

hash.o: hash.c hash.h khash.h

lexicon.o: lexicon.c pagc_api.h pagc_std_api.h

pagc_tools.o: pagc_tools.c pagc_tools.h pagc_common.h

parseaddress-api.o: parseaddress-api.c parseaddress-api.h parseaddress-stcities.h parseaddress-regex.h

standard.o: standard.c pagc_api.h

tokenize.o: tokenize.c pagc_api.h

std_pg_hash.o: std_pg_hash.c std_pg_hash.h pagc_api.h pagc_std_api.h

#only extension files	
DATA += $(wildcard sql/*--*.sql)
EXTRA_CLEAN += $(wildcard expected/*--*.out)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql *.a *.so *.dll

PGXS := /var/lib/jenkins/workspace/pg/rel/pg9.3w64/lib/postgresql/pgxs/src/makefiles/pgxs.mk
include $(PGXS)

=== extensions/postgis/Makefile ===
include ../upgradeable_versions.mk

EXTENSION     = postgis
EXTVERSION    = 2.2.1
MINORVERSION  = 2.2
GREP = /bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

#DOCS         = $(wildcard ../../doc/html/*.html)
PG_CONFIG    = /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += ${SQL_BITS} sql/*.sql

# Update PREV_big manually on branching
# TODO: move this definition in ../../Version.config
PREV_big=21
CURV_big=22

ifeq ($(PG91),yes)
	
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql sql_minor_upgrade

sql/$(EXTENSION).sql: sql_bits/postgis.sql sql_bits/postgis_comments.sql sql_bits/rtpostgis.sql sql_bits/mark_editable_objects.sql.in sql_bits/raster_comments.sql sql_bits/spatial_ref_sys.sql
	mkdir -p sql
	echo '\echo Use "CREATE EXTENSION $(EXTENSION)" to load this file. \quit' > $@
	cat $^ >> $@

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@

sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../postgis/postgis.sql ../../raster/rt_pg/rtpostgis.sql ../../utils/create_unpackaged.pl
	mkdir -p sql
	cat ../../postgis/postgis.sql ../../raster/rt_pg/rtpostgis.sql | $(PERL) ../../utils/create_unpackaged.pl postgis > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: sql_bits/postgis_raster_upgrade_minor.sql
	cp $< $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql_bits/postgis_raster_upgrade_minor.sql
	cp $< $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/spatial_ref_sys.sql: ../../spatial_ref_sys.sql	
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/postgis.sql: ../../postgis/postgis.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

../../doc/postgis_comments.sql:
	$(MAKE) -C ../../doc comments

sql_bits/postgis_comments.sql: ../../doc/postgis_comments.sql
	cp $< $@

#strip BEGIN/COMMIT since these are not allowed in extensions
sql_bits/rtpostgis.sql: ../../raster/rt_pg/rtpostgis.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

# we need to also drop this temporary function from the extension
# for casts that are being dropped we need to drop them 
# from extension only if they are in the existension so we use our postgis_extension_drop..
# so that it will silently fail if cast is not in extension
sql_bits/rtpostgis_upgrade.sql: ../../raster/rt_pg/rtpostgis_upgrade.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		-e 's/DROP FUNCTION _rename_raster_tables();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _rename_raster_tables();DROP FUNCTION _rename_raster_tables();/g' \
		-e 's/DROP FUNCTION _drop_st_samealignment();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION _drop_st_samealignment();DROP FUNCTION _drop_st_samealignment();/g' \
		-e 's/DROP CAST\(.*\)/SELECT postgis_extension_drop_if_exists('\''$(EXTENSION)'\'', '\''DROP CAST \1'\'');DROP CAST \1/' \
	$< > $@

#don't drop casts just yet since we don't have provision to remove from extension yet
#need to also drop temporary functions from extenions since it gets auto-added
sql_bits/postgis_upgrade.sql: ../../postgis/postgis_upgrade.sql 
		 sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
		 -e '/^\(DROP\|CREATE\) \(CAST\).*;/d' \
		 -e '/^\(DROP\|CREATE\) \(CAST\)/,/\;/d' \
		 -e 's/DROP FUNCTION postgis_major_version_check();/ALTER EXTENSION ${EXTENSION} DROP FUNCTION postgis_major_version_check();DROP FUNCTION postgis_major_version_check();/g' \
	 	 $< > $@


../../doc/raster_comments.sql:
	$(MAKE) -C ../../doc comments

sql_bits/raster_comments.sql: ../../doc/raster_comments.sql
	cp $< $@

#postgis_raster_upgrade_minor.sql is the one that contains both postgis AND raster
#TODO: come up with a better name
#TODO: what about postgis_drop_after.sql ? where does it fit ??
sql_bits/postgis_raster_upgrade_minor.sql: ../postgis_extension_helper.sql sql_bits/postgis_upgrade.sql sql_bits/rtpostgis_upgrade.sql ../../doc/raster_comments.sql ../../doc/postgis_comments.sql ../postgis_extension_helper_uninstall.sql
	echo '\echo Use "CREATE EXTENSION $(EXTENSION)" to load this file. \quit' > $@
	cat $^ >> $@

sql_minor_upgrade: sql_bits/postgis_raster_upgrade_minor.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $< > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/postgis--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm -f Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
PERL=/usr/bin/perl

=== extensions/postgis_sfcgal/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_sfcgal
EXTVERSION    = 2.2.1
MINORVERSION  = 2.2
GREP = /bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

PG_CONFIG    =  /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS} 


ifeq ($(PG91),yes)
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@
	
sql/$(EXTENSION).sql: sql_bits/sfcgal.sql  sql_bits/sfcgal_comments.sql
	mkdir -p sql
	cat $^ > $@

#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: sql_bits/sfcgal_upgrade_minor.sql
	mkdir -p sql
	cat $^ > $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql
	mkdir -p sql
	cp $< $@
	
sql_bits/sfcgal.sql: ../../postgis/sfcgal.sql
	mkdir -p sql_bits
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@
	
../../doc/sfcgal_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/sfcgal_comments.sql: ../../doc/sfcgal_comments.sql
	mkdir -p sql_bits
	cp $< $@
	
#grep all lines that start with CREATE OR REPLACE FUNCTION, TRIGGER...
#then replace CREATE OR REPLACE .. with ALTER EXTENSION..;
#then remove default values and extra junk
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/sfcgal.sql ../../utils/create_unpackaged.pl
	mkdir -p sql
	cat $< | ../../utils/create_unpackaged.pl ${EXTENSION} > $@

sql_bits/sfcgal_upgrade.sql : ../../postgis/sfcgal_upgrade.sql
	mkdir -p sql_bits
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g'  $< > $@

sql_bits/sfcgal_upgrade_minor.sql: ../postgis_extension_helper.sql sql_bits/sfcgal_upgrade.sql ../../doc/sfcgal_comments.sql ../postgis_extension_helper_uninstall.sql
	mkdir -p sql_bits
	echo '\echo Use "CREATE EXTENSION $(EXTENSION)" to load this file. \quit' > $@
	cat $^ >> $@

sql_minor_upgrade: sql_bits/sfcgal_upgrade_minor.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $< > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done
	
DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

=== extensions/postgis_tiger_geocoder/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_tiger_geocoder
EXTVERSION    = 2.2.1
MINORVERSION  = 2011.2.2
GREP = /bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))
REGRESS = test-normalize_address
REGRESS_OPTS = --load-extension=fuzzystrmatch --load-extension=postgis --load-extension=$(EXTENSION)

PG_CONFIG    =  /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS} 

#test address standardizer if also built
ifeq (address_standardizer,address_standardizer)
	REGRESS +=  test-pagc_normalize_address
	REGRESS_OPTS += --load-extension=address_standardizer
endif

ifeq ($(PG91),yes)
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql  sql_minor_upgrade sql/test-normalize_address.sql  sql/test-pagc_normalize_address.sql expected/test-normalize_address.out expected/test-pagc_normalize_address.out sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql  sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	mkdir -p expected
	cp $< $@


expected/test-normalize_address.out: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/normalize_address_regress
	cat $^ > $@
	
expected/test-pagc_normalize_address.out: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/pagc_normalize_address_regress
	cat $^ > $@
	
## adding \t .. to force output to be the same as what get in regular regress in tiger folder
sql/test-normalize_address.sql: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/normalize_address_regress.sql
	mkdir -p sql
	cat $^ > $@
	
sql/test-pagc_normalize_address.sql: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/pagc_normalize_address_regress.sql
	mkdir -p sql
	cat $^ > $@
	
sql/$(EXTENSION).sql: sql_bits/tiger_geocoder.sql  sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql
	mkdir -p sql
	cat $^ > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	mkdir -p sql
	cat $^ > $@


sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql
	mkdir -p sql
	cp $< $@
	
#strip BEGIN/COMMIT since these are not allowed in extensions
#strip CREATE SCHEMA since we force extension 
# to create schema by setting schema to tiger_geocoder in control
sql_bits/tiger_geocoder_minor.sql.in: ../../extras/tiger_geocoder/utility/set_search_path.sql \
  	../../extras/tiger_geocoder/geocode_settings.sql \
  ../../extras/tiger_geocoder/tiger_loader_2015.sql \
	../../extras/tiger_geocoder/utility/utmzone.sql \
	../../extras/tiger_geocoder/utility/cull_null.sql \
	../../extras/tiger_geocoder/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/normalize/count_words.sql \
	../../extras/tiger_geocoder/normalize/state_extract.sql \
	../../extras/tiger_geocoder/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract.sql \
	../../extras/tiger_geocoder/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/pagc_normalize/pagc_tables.sql \
  ../../extras/tiger_geocoder/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/geocode/includes_address.sql \
	../../extras/tiger_geocoder/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/geocode/geocode.sql \
	../../extras/tiger_geocoder/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/geocode/census_tracts_functions.sql
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql.in: sql_bits/norm_addy_create.sql.in \
	../../extras/tiger_geocoder/utility/set_search_path.sql \
	../../extras/tiger_geocoder/geocode_settings.sql \
	../../extras/tiger_geocoder/tables/lookup_tables_2011.sql \
	../../extras/tiger_geocoder/tiger_loader_2015.sql \
	../../extras/tiger_geocoder/utility/set_search_path.sql \
	../../extras/tiger_geocoder/utility/utmzone.sql \
	../../extras/tiger_geocoder/utility/cull_null.sql \
	../../extras/tiger_geocoder/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/normalize/count_words.sql \
	../../extras/tiger_geocoder/normalize/state_extract.sql \
	../../extras/tiger_geocoder/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract.sql \
	../../extras/tiger_geocoder/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/pagc_normalize/pagc_tables.sql \
    ../../extras/tiger_geocoder/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/geocode/includes_address.sql \
	../../extras/tiger_geocoder/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/geocode/geocode.sql \
	../../extras/tiger_geocoder/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/geocode/census_tracts_functions.sql \
	../../extras/tiger_geocoder/topology/tiger_topology_loader.sql \
	../postgis_extension_helper.sql \
	sql_bits/add_search_path.sql \
	../postgis_extension_helper_uninstall.sql 
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql: sql_bits/tiger_geocoder.sql.in
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
sql_bits/add_search_path.sql: sql_bits/add_search_path.sql.in
	cp $< $@
	
../../doc/tiger_geocoder_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/tiger_geocoder_comments.sql: ../../doc/tiger_geocoder_comments.sql
	cp $< $@
	
#grep all lines that start with CREATE OR REPLACE FUNCTION, TRIGGER...
#then replace CREATE OR REPLACE .. with ALTER EXTENSION..;
#then remove default values and extra junk
# sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../tiger_geocoder/tiger_geocoder.sql
# 	sed -e '/^CREATE \(OR REPLACE\|TYPE\|TABLE\|VIEW\|CAST\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [\.0-9a-zA-Z]\+//g' \
# 		-e 's/\(BEFORE\|WITH FUNCTION\)\(.*\)/;/' \
# 		-e 's/[ \t]+;/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@

#hardcode for now using 
#the extensions/make_unpackaged.sql script form an install
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/tiger_geocoder--unpackaged.sql.in
	mkdir -p sql
	cp $< $@

#upgrade script should have everything but table, schema, type creation/alter
#NOTE: we assume all object definitions end in ;
#first expression deletes all non-removable objects defined on same line
#second deletes all non-removable defined on multiple lines 
#  the end of the body of object we assume ends in ;
#aggregates are special 
#they can be dropped but we need to remove
#them from the extension first
sql/tiger_geocoder_upgrade_minor.sql:  sql_bits/tiger_geocoder_minor.sql.in 
	mkdir -p sql
	 sed -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\).*;/d' \
	 	 -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\)/,/\;/d' \
	 	 -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
	 	 $< > $@
	 	 	
sql_minor_upgrade: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $^ > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

#only extension files	
DATA = ${EXTENSION}.control sql/$(EXTENSION).sql $(wildcard sql/*--*.sql)
EXTRA_CLEAN += $(wildcard expected/*--*.out)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)

=== extensions/postgis_topology/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_topology
EXTVERSION    = 2.2.1
MINORVERSION  = 2.2
GREP=/bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))

PG_CONFIG    = /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS}


ifeq ($(PG91),yes)

all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	cp $< $@
	
sql/$(EXTENSION).sql: extlock.sql sql_bits/topology.sql  sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql
	mkdir -p sql
	cat $^ > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: extlock.sql ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/topology_upgrade.sql sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql ../postgis_extension_helper_uninstall.sql
	cat $^ > $@
sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql
	cat $^ > $@
	
#strip BEGIN/COMMIT since these are not allowed in extensions
#strip CREATE SCHEMA since we force extension 
# to create schema by setting schema to topology in control
sql_bits/topology.sql: ../../topology/topology.sql
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
../../doc/topology_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/topology_comments.sql: ../../doc/topology_comments.sql
	cp $< $@
	
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../topology/topology.sql ../../utils/create_unpackaged.pl
	mkdir -p sql
	cat $< | $(PERL) ../../utils/create_unpackaged.pl postgis_topology > $@

#upgrade script should have everything but table, schema, type creation/alter
#NOTE: we assume all object definitions end in ;
#first expression deletes all non-removable objects defined on same line
#second deletes all non-removable defined on multiple lines 
#  the end of the body of object we assume ends in ;
#aggregates are special 
#they can be dropped but we need to remove
#them from the extension first
sql/topology_upgrade.sql:  ../../topology/topology_upgrade.sql
	 sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
sql_minor_upgrade: extlock.sql ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/topology_upgrade.sql sql_bits/mark_editable_objects.sql.in sql_bits/topology_comments.sql ../postgis_extension_helper_uninstall.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $^ > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

DATA = $(wildcard sql/*--*.sql)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
PERL=/usr/bin/perl

=== doc/po/it_IT/Makefile ===
DOCSUFFIX=-it
include ../Makefile.local

=== doc/po/pl/Makefile ===
DOCSUFFIX=-pl
include ../Makefile.local

=== debian/changelog ===
postgis (2.2.1+dfsg-2ubuntu0.1) xenial-security; urgency=medium

  * SECURITY UPDATE: An empty argument in a postgis function can cause a DoS
    in PostgreSQL. This fix avoid it.
    - debian/patches/CVE-2017-18359.patch: ST_AsX3D handle empty geometries.
    - CVE-2017-18359

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Wed, 13 Feb 2019 12:07:43 -0200

=== debian/control ===
Source: postgis
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Stephen Frost <sfrost@debian.org>, Francesco Paolo
 Lovergine <frankie@debian.org>, Markus Wanner <markus@bluegap.ch>,
 Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper (>= 9), po-debconf,
 dpkg-dev (>= 1.16.1~), autotools-dev, dh-autoreconf, autoconf2.13,
 flex, bison, rdfind, libgeos-dev (>= 3.3),
 libjson-c-dev | libjson0-dev (>= 0.9~), libsfcgal-dev [!armel],
 libproj-dev (>= 4.6.0), libssl-dev, xsltproc, docbook, docbook-xsl,
 imagemagick, libcunit1-dev, dblatex, libxml2-dev (>= 2.5.0~),
 libgtk2.0-dev, libgdal-dev (>= 1.11.2+dfsg-3~) | libgdal1-dev (>= 1.9.0~),
 postgresql-server-dev-all, postgresql-common (>= 148~), postgresql
Standards-Version: 3.9.6
Homepage: http://postgis.net/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/postgis.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/postgis.git

Package: postgis
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: postgresql-9.5-postgis-2.2, postgis-doc
Description: Geographic objects support for PostgreSQL
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS userland binaries, common files.

Package: postgis-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: postgis
Description: Geographic objects support for PostgreSQL -- documentation
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains the PostGIS documentation.

Package: liblwgeom-2.2-5
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: PostGIS "Lightweight Geometry" library
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This library is the generic geometry handling section of PostGIS. The
 geometry objects, constructors, destructors, and a set of spatial
 processing functions, are implemented here.

Package: liblwgeom-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 liblwgeom-2.2-5 (= ${binary:Version})
Breaks: postgis (<< 2.0.0)
Description: PostGIS "Lightweight Geometry" library - Development files
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This library is the generic geometry handling section of PostGIS. The
 geometry objects, constructors, destructors, and a set of spatial
 processing functions, are implemented here.  This package contains
 the development files.

Package: postgresql-9.5-postgis-2.2
Depends: ${shlibs:Depends}, postgresql-9.5,
 postgresql-9.5-postgis-scripts, liblwgeom-2.2-5,
 ${misc:Depends}
Recommends: postgresql-contrib-9.5
Suggests: postgis
Breaks: postgis (<< 1.2.1)
Architecture: any
Description: Geographic objects support for PostgreSQL 9.5
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package supports PostgreSQL 9.5.

Package: postgresql-9.5-postgis-scripts
Architecture: all
Depends: ${misc:Depends}
Recommends: postgresql-9.5-postgis-2.2
Replaces: postgresql-9.5-postgis-2.0-scripts (<< 2.1.0~),
 postgresql-9.5-postgis-2.1-scripts (<< 2.1.0-4~)
Breaks: postgresql-9.5-postgis-2.0-scripts (<< 2.1.0~),
 postgresql-9.5-postgis-2.1-scripts (<< 2.1.0-4~)
Description: Geographic objects support for PostgreSQL 9.5 -- scripts
 PostGIS adds support for geographic objects to the PostgreSQL
 object-relational database. In effect, PostGIS "spatially enables"
 the PostgreSQL server, allowing it to be used as a backend spatial
 database for geographic information systems (GIS), much like ESRI's
 SDE or Oracle's Spatial extension. PostGIS follows the OpenGIS
 "Simple Features Specification for SQL".
 .
 This package contains SQL scripts to upgrade from earlier PostGIS
 versions for PostgreSQL 9.5 as well as Perl utility scripts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CHECK = check
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	CHECK =
endif

# Hurd doesn't implement semaphores; skip regress tests
# mipsel has persisent buildd issues, skip tests too.
# armel has no sfcgal support, and fails interrupt_buffer test.
# kfreebsd-i386 & mips64el are not a release architecture
ifneq (,$(findstring $(DEB_HOST_ARCH),"hurd-i386 mipsel armel kfreebsd-i386 mips64el"))
	CHECK =
endif

# Magic to automatically create a debian/control file for the (or all)
# supported versions of Postgres.
#
# Blatantly copied from
# /usr/share/postgresql-common/pgxs_debian_control.mk and extended to
# support NEWEST_VERSION and fiddle with postgis 2.0 transitional
# packages.
debian/control: debian/control.in debian/pgversions
	(set -e; \
	VERSIONS=`pg_buildext supported-versions $(CURDIR)` || exit $$?; \
	NEWEST_VERSION=`pg_buildext supported-versions $(CURDIR) | tail -1` || exit $$?; \
	grep-dctrl -vP PGVERSION $< | \
		sed -e "s:NEWEST_PGVERSION:$$NEWEST_VERSION:" > $@.pgxs_tmp; \
	for v in $$VERSIONS; do \
		grep-dctrl -P PGVERSION $<      \
			| sed -e "s:PGVERSION:$$v:" >> $@.pgxs_tmp; \
	done; \
	mv $@.pgxs_tmp $@) || (rm -f $@.pgxs_tmp; exit 1)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH      ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Upstream version (including ~rcN) for symbols version
UPSTREAM_VERSION := $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

MAJOR_VERSION = $(shell grep ^POSTGIS_MAJOR_VERSION Version.config|cut -d= -f2)
MINOR_VERSION = $(shell grep ^POSTGIS_MINOR_VERSION Version.config|cut -d= -f2)
MICRO_VERSION = $(shell grep ^POSTGIS_MICRO_VERSION Version.config|cut -d= -f2)
POSTGIS_VERSION = $(MAJOR_VERSION).$(MINOR_VERSION).$(MICRO_VERSION)
ifeq ($(POSTGIS_VERSION),..)
$(error Cannot detect Postgis version, fix debian/rules)
endif

LIBLWGEOM_CURRENT   = $(shell grep ^LIBLWGEOM_IFACE_CUR Version.config | cut -d= -f2)
LIBLWGEOM_REVISION  = $(shell grep ^LIBLWGEOM_IFACE_REV Version.config | cut -d= -f2)
LIBLWGEOM_AGE       = $(shell grep ^LIBLWGEOM_IFACE_AGE Version.config | cut -d= -f2)
LIBLWGEOM_SOVERSION = $(shell expr $(LIBLWGEOM_CURRENT) - $(LIBLWGEOM_AGE))
ifeq ($(LIBLWGEOM_SOVERSION),)
$(error Cannot detect liblwgeom SOVERSION, fix debian/rules)
endif

# For the Postgres APT repository, we want to support multiple
# Postgres versions. However, docs and the JDBC jar only need to be
# built once - in the main directory.
NEWEST_POSTGRES_VERSION = $(shell pg_buildext supported-versions $(CURDIR)|tail -1)
ifeq ($(NEWEST_POSTGRES_VERSION),)
$(error Cannot detect Postgres version, check debian/pgversions and pg_buildext)
endif

OTHER_POSTGRES_VERSIONS = $(shell pg_buildext supported-versions $(CURDIR)\
	| grep -v "$(NEWEST_POSTGRES_VERSION)")

COMMON_CONFIGURE_ARGS = --host=$(DEB_HOST_GNU_TYPE) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--prefix=/usr \
	--exec-prefix=\$${prefix} \
	--docdir=\$${prefix}/share/doc \
	--mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info \
	--with-gui

clean: debian/control
	dh_testdir
	dh_testroot

#	Clean all separate build directories.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		rm -rf $(CURDIR)/debian/build-$$PGVER; \
	done)

	[ ! -f GNUmakefile ] || $(MAKE) distclean || true
	[ ! -f GNUmakefile ] || $(MAKE) -C doc images-clean || true

#	Cleanup after the Makefile
	rm -f postgis/postgis_upgrade_20_minor.sql.in \
		raster/rt_pg/rtpostgis_drop.sql \
		raster/rt_pg/rtpostgis_upgrade_cleanup.sql

#	Cleanup auto-generated packaging control files
	rm -f $(CURDIR)/debian/postgresql-*-postgis-2.2.install
	rm -f $(CURDIR)/debian/postgresql-*-postgis-scripts.install
	rm -f loader/cunit/cu_tester
	rm -rf liblwgeom/cunit/.libs

#	Cleanup the temporary environment file.
	rm -f postgis-check-env.tmp

	dh_autotools-dev_restoreconfig
	dh_autoreconf_clean
	dh_clean

configuration: configuration-stamp
configuration-stamp:
	dh_testdir
	dh_prep -s

#	Run autoreconf *before* coying sources around.
	dh_autoreconf autoconf
	dh_autotools-dev_updateconfig

#	Copy sources required to build extensions for all but the most
#	recent Postgres version. Unfortunately, Postgis doesn't support
#	vpath builds.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		mkdir $(CURDIR)/debian/build-$$PGVER; \
		for FILE in `ls $(CURDIR)|grep -v debian`; do \
			cp -a $$FILE $(CURDIR)/debian/build-$$PGVER; \
		done; \
	done)

#	PostGIS for the most recent PostgreSQL version
	./configure $(COMMON_CONFIGURE_ARGS) \
		--datadir=\$${prefix}/share/postgresql-$(NEWEST_POSTGRES_VERSION)-postgis \
		--with-pgconfig=/usr/lib/postgresql/$(NEWEST_POSTGRES_VERSION)/bin/pg_config

#	PostGIS for all older Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		cd $(CURDIR)/debian/build-$$PGVER; \
		./configure $(COMMON_CONFIGURE_ARGS) \
			--datadir=\$${prefix}/share/postgresql-$$PGVER-postgis \
			--with-pgconfig=/usr/lib/postgresql/$$PGVER/bin/pg_config; \
	done)

	touch $@

build: build-arch build-indep

build-arch: build-arch-stamp check
build-arch-stamp: configuration-stamp
#	Build against the newest Postgres version
	$(MAKE)
	$(MAKE) -C doc

#	Build against all other Postgres versions
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
		$(MAKE) -C $(CURDIR)/debian/build-$$PGVER; \
	done)

	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configuration-stamp build-arch-stamp
#	Let PostGIS create a perl script from postgis_restore.pl.in
	$(MAKE) -C utils

#	Create a few SQL scripts that the Makefiles are not clever enough
#	to resolve, when building arch-indep only.
	$(MAKE) -C postgis postgis.sql postgis_upgrade.sql
	$(MAKE) -C raster/rt_pg rtpostgis.sql rtpostgis_upgrade.sql
	$(MAKE) -C topology topology.sql topology_upgrade.sql

#	This creates the required SQL scripts. Again, the Makefile is not
#	clever enough to run this before 'install'.
	$(MAKE) -C extensions

	touch $@

check: build-arch-stamp
#   Run unit tests (against the newest Postgres version only, for
#   now).
	echo "LD_PRELOAD = '$(CURDIR)/liblwgeom/.libs/liblwgeom-$(MAJOR_VERSION).$(MINOR_VERSION).so.$(LIBLWGEOM_SOVERSION)'" \
		> $(CURDIR)/postgis-check-env.tmp
	(set -e; \
		test -z '$(CHECK)' || \
		pg_virtualenv -v $(NEWEST_POSTGRES_VERSION) \
			-c '--environment $(CURDIR)/postgis-check-env.tmp' make check || (\
		for LOGFILE in /tmp/pgis_reg/test_*_diff; do \
			echo " ### $$LOGFILE ###"; \
			cat $$LOGFILE; \
		done; \
		echo " ### end of log dumps ###"; \
		exit 2) \
	)

install: install-indep install-arch

install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i 
	dh_installdirs -i

#	Install the most recent Postgres version. Note that we used to
#	install only utils and extensions. However, there are sql scripts
#	in postgis, raster and topology as well, which need to be
#	installed for the -scripts package(s).
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp

#	Install all older Postgres versions.
	(set -e; \
	for PGVER in $(OTHER_POSTGRES_VERSIONS); do \
